
#include "dtc2.h"

#define BTROM

int fpgaconfPC(char *);
int fpgaconfPROM(void);
int fpgaconfTAB(void);
int fpgatest(void);

long QRAM = 0;

char fn[64] = "dtc2x.bit";
int resetX,resetP,resetT,ispause;
int HWxmode;

char dline[] = "-------------------------------------------------------------------";

extern unsigned char INV[];

int in_debug_mode=0;
int bootmode=0,Resetp=0,LoadFile=0,StopMon=0;
char lodfile[256];
unsigned lowestP;

OnCEregs Oregs;
DSPregs  Dregs;

ulong bk_hi=0,bk_lo=0,bk_cnt=0;
int   isbk=0;

unsigned short DOSMEM;


/* ----------------------------------------------------------------- */
/*
  test DTC2 present *and* FPGA initialised - no OnCE otherwise!
*/

int DTC2present(long *QRAM)
{
 int k,seg=0,err;
 char *es;

  err=1;
/* reset XMODE */
  outb(0,oXMODE);
  HWxmode = inb(iXMODE)&1;	/* 1 if inv(PC), 0 if PROM */

/* toggle/test XMODE */
  outb(1,oXMODE);
  if ((inb(iXMODE)&1)^HWxmode) err=0;
  outb(0,oXMODE);
  if ((inb(iXMODE)&1)^HWxmode) err=0;
  if (err) return(1);		/* no DTC2, no FPGA to test */

  *QRAM=0;
  es=getenv("DTCQRAM");
  if (es==NULL) err=1;
  else {
    if (sscanf(es,"%x",&k)==1) {
      switch(k) {
	case 0: case 0xc8: case 0xc800: seg=0xc8000; break;
	case 1: case 0xcc: case 0xcc00: seg=0xcc000; break;
	case 2: case 0xd0: case 0xd000: seg=0xd0000; break;
	default: err=1;
       }
      if (!err) *QRAM=seg;
     }
   }
  if (*QRAM==0)
    fprintf(stderr,"Invalid DTCQRAM environment setting\n");

  return(!err);
}


/* ----------------------------------------------------------------- */


void PAUSE(void)
{
  if (ispause) {
    printf("--Paused--\n");
    getch();
   }
}


static void wr1link(char b)
{
 int t=20000;
  while (((inb(C012+3)&1)==0)&&(--t));
  if (t) outb(b,C012+1);
}

static int rd1link(void)
{
 int t=20000;
  while (((inb(C012+2)&1)==0)&&(--t));
  return (t? inb(C012):-1);
}

static void wr4link(ulong v)
{
  wr1link(v&0xff); v>>=8;
  wr1link(v&0xff); v>>=8;
  wr1link(v&0xff); v>>=8;
  wr1link(v&0xff);
}

static ulong rd4link(void)
{
 ulong v;
  v =(long)rd1link();
  v|=((long)rd1link()<<8);
  v|=((long)rd1link()<<16);
  v|=((long)rd1link()<<24);
  return(v);
}


static long dspread_t (long t)
{
 register int val;

  while (((inb(HI_ISR)&0xf1)==0)&&(--t)); if (t==0) return(-1l);

  __asm__ __volatile__ ("xorl %%eax,%%eax\n\tmovw %1,%%dx"
	"\n\tcli"
	"\n\tinb  %%dx,%%al"
	"\n\tshll $8,%%eax"
	"\n\tincw %%dx"
	"\n\tinb  %%dx,%%al"
	"\n\tshll $8,%%eax"
	"\n\tincw %%dx"
	"\n\tinb  %%dx,%%al"
	"\n\tsti"
	"\n\tmovl %%eax,%0"
	: "=g"(val)
	: "n"(HI_RXH)
	: "eax", "edx", "memory");

  return val;
}


/* ----------------------------------------------------------------- */


void resetall(void)
{
  outb(0,oTANALY);
  outb(0,oTRESET);
  outb(1,oECF2);
  outb(0,oECF3);
  outb(1,oTRESET);	/* reset T425 */
  outb(0,oDRES);	/* reset DSP  */
  outb(0,oXMODE);
  outb(0,oDMODE);
  outb(0,oXPROG);	/* inv */
  delay(100);
  outb(0,oTRESET);
}


int memtest(void)
{
 long mem[3] = { 0xc8000, 0xcc000, 0xd0000 };
 long mofs;
 int i,k,srch;

  srch=(QRAM==0);
  printf(srch? "Memory test":"Environment");

  if (srch) {
    for (k=0; k<3; k++) {
      mofs=mem[k];
      i = _farpeekb(DOSMEM,mofs+M401+6);
      outb(0x55,M401+6);
      if (_farpeekb(DOSMEM,mofs+M401+6)==0x55) {
	outb(0xaa,M401+6);
	if (_farpeekb(DOSMEM,mofs+M401+6)==0xaa) break;
       }
      _farpokeb(DOSMEM,mofs+M401+6,i);
     }
    if (k>=3) return(1);
    QRAM=mem[k];
  }
  printf(" says QRAM at %08lx ",QRAM);

  printf("*");
  mofs=QRAM;
  for (i=0; i<1024; i++) {
    _farpokeb(DOSMEM,mofs,0xaa); mofs++;
   }
  printf("*");
  mofs=QRAM;
  for (i=0; i<1024; i++) {
    if (_farpeekb(DOSMEM,mofs)!=0xaa) return(1);
    _farpokeb(DOSMEM,mofs,i&0xff); mofs++;
   }
  printf("*");
  mofs=QRAM;
  for (i=0; i<1024; i++) {
    if (_farpeekb(DOSMEM,mofs)!=(i&0xff)) return(1);
    _farpokeb(DOSMEM,mofs,0xff); mofs++;
   }
  printf("*");
  mofs=QRAM;
  for (i=0; i<1024; i++) {
    if (_farpeekb(DOSMEM,mofs)!=0xff) return(1);
    _farpokeb(DOSMEM,mofs,0); mofs++;
   }
  printf("*");
  mofs=QRAM;
  for (i=0; i<1024; i++) {
    if (_farpeekb(DOSMEM,mofs)!=0) return(1);
   }
  return(0);
}


/* ------------------------------------------------------------------- */


int C012test(void)
{
 int r2,r3;

  outb(1,oTRESET);	/* reset T425 */
  delay(100);
  outb(0,oTRESET);
  printf("C012: %02x %02x %02x %02x",inb(C012),inb(C012+1),
	(r2=inb(C012+2)),(r3=inb(C012+3)));
  if ((r2!=0) || (r3!=1)) return(1);
  outb(2,C012+2);
  if (inb(C012+2)!=2) return(2);
  outb(0,C012+2);
  outb(2,C012+3);
  if (inb(C012+3)!=3) return(3);
  outb(0,C012+3);

  return(0);
}


int T_test(void)
{
 ulong u,v;

  u=0x55aa5aa5;
  wr1link(0); wr4link(0x80000080); wr4link(u);	/* poke */
  wr1link(1); wr4link(0x80000080); v=rd4link();
  if (u==v) {
    u=0xaa334679;
    wr1link(0); wr4link(0x80000800); wr4link(u);	/* poke */
    wr1link(1); wr4link(0x80000800); v=rd4link();
    return (u!=v);
   }
  return(1);
}


int dspstart(void)		/* try to start DSP from Flash */
{
 int err;
 long v;

#ifdef BTROM
  outb(1,oDMODE);
  outb(1,oDRES);
  delay(200);
  err=0; v=-1l;
  if (inb(HI_ISR)==0xff) err=1; else {
    v=dspread_t(1000000);
   }
  printf("DSP init from ROM says %06lx\n",v);
  if (v!=0x56002) err=1;
  outb(0,oDMODE);
  return(err);
#else
  return(0);
#endif
}


/* ------------------------------------------------------------------- */


void main (int argc, char *argv[])
{
 char buf[128];
 int err,terr,retcode,i,j,k,n;
 int FPGAmode,FPGAdone,FPGAerr;
 char *p;

  DOSMEM = _go32_conventional_mem_selector();

  printf("%s\nDTC2 init ["__DATE__" "__TIME__"]\n",dline);
  resetX=0; resetP=0; resetT=0;
  ispause=0;

  retcode=0;
  for (i=0; i<255; i++) {
    j=i; k=0;
    for (n=0; n<7; n++) { if (j&1) k|=1; j>>=1; k<<=1; }
    INV[i]=k|j;
   }

  k=argc; *buf=0;
  while (--k) {
    p=argv[k];
    if ((*p=='-')||(*p=='/')) {
      switch(p[1]) {
	case 'p': ispause=(p[2]!='-'); break;
/* -rp=PROM -rf=FILE -r|-rt=TABLE */
	case 'r': if (p[2]=='p') resetP=(p[3]!='-');
		  else
		   if (p[2]=='f') resetX=(p[3]!='-');
		   else
		    if (p[2]=='t') resetT=(p[3]!='-');
		     else resetT=(p[2]!='-');
		  break;
	default:  break;
       }
     }
    else strcpy(buf,p);
  }
  if (resetX && *buf) strcpy(fn,buf);

  if (!DTC2present(&QRAM)) {
    printf("DTC2 not found\n"); retcode=1;
    goto quit;
   }

  resetall();

  FPGAerr = inb(iXINIT)&1;
  FPGAdone = inb(iXDONE)&1;
  FPGAmode = inb(iXMODE)&1;

  err=0;
  printf("FPGA mode=%d err=%d done=%d - ",FPGAmode,FPGAerr,FPGAdone);
  k = inb(iXDONE)&1;
  if (!k) printf("FPGA not configured\n");
    else printf("FPGA already configured\n");
/*  if (resetX||resetP) printf("reconfiguring FPGA\n"); */

  if ((!k)||resetX||resetP||resetT) {
    if (resetP) {
      outb(HWxmode,oXMODE);
      err=fpgaconfPROM();
     }
    else if (resetX||resetT) {
/* reset from PC - put in mode 1 */
      outb(!HWxmode,oXMODE);
      if (resetX) {
	if ((err=fpgaconfPC(fn))) {
	  printf("Oops..."); err=fpgaconfPC(fn);
	 }
       }
      else if (resetT) {
	if ((err=fpgaconfTAB())) {
	  printf("Oops..."); err=fpgaconfTAB();
	 }
       }
     }
   }

  if (!err) {
    delay(50);
/* test echo of CTRL0 bit */
    outb(1,FPGA);
    if ((inb(FPGA+1)&0x20)==0) err=1;
    outb(0,FPGA);
    if ((inb(FPGA+1)&0x20)!=0) err=1;
   }
  if (err) {
    printf("error in FPGA config\n");
    retcode=1; goto quit;
   }
  outb(!HWxmode,oXMODE);	/* set FPGA mode always to 1 */
  printf("FPGA version is %02x:%02x\n",inb(FPGA),inb(FPGA+1));

  if (memtest()) {
    printf(" Error\n");
   }
  else printf(" OK\n");

  if ((terr=C012test())) {
    printf(" - Error %d in C012 test\n",terr);
   }
  else {
    printf(" - C012 test ok");
    if (T_test())
      printf(" - Error in T425 test\n");
    else
      printf(" - T425 test ok\n");
   }

  err=dspstart();

quit:
  printf("%s\n",dline);
  if (terr)
    outb(1,oTRESET);	/* reset T425 */
  if (err)
    outb(0,oDRES);		/* reset DSP  */
  outb(0,FPGA);		/* special feature off */

  exit(retcode);
}

